<?php
/**
 * @package     WordPress
 * @subpackage  Nuno Page Builder
 * @author      support@themegum.com
 * @since       2.0.4
*/
defined('ABUILDER_BASENAME') or die();

if (is_plugin_active('woocommerce/woocommerce.php')){

/* WooCommerce Shortcode */

add_builder_element('recent_products',
   array( 
    'title' => esc_html__( 'Recent Products', 'nuno-builder' ),
    'icon'  => 'dashicons woo-admin-generic',
    'color' =>'#f17dad',
    'order'=>50,
    'options' => array(  
        array( 
          'heading' => esc_html__('Num Product','nuno-builder' ),
          'param_name' => 'per_page',
          'admin_label' => true,
          'class' => 'small',
          'description' => esc_html__('Num product to show','nuno-builder' ),
          'value' => '',
          'type' => 'textfield'
         ), 
        array( 
        'heading' => esc_html__( 'Columns', 'nuno-builder' ),
        'param_name' => 'columns',
        'admin_label' => true,
        'description' => esc_html__( 'Number of product column', 'nuno-builder' ),
        'class' => '',
        'value'=>array(
            '1' => esc_html__('One Column','nuno-builder'),
            '2' => esc_html__('Two Columns','nuno-builder'),
            '3' => esc_html__('Three Columns','nuno-builder'),
            '4' => esc_html__('Four Columns','nuno-builder'),
            '5' => esc_html__('Five Columns','nuno-builder'),
            '6' => esc_html__('Six Columns','nuno-builder')
            ),
        'type' => 'dropdown',
         ),     
        array( 
          'heading' => esc_html__( 'Order By', 'nuno-builder' ),
          'param_name' => 'orderby',
          'class' => '',
          'value' => array(
            ''=>esc_html__('Default','nuno-builder') ,
            'date'=>esc_html__('Date','nuno-builder') ,
            'name'=>esc_html__('Name','nuno-builder') ,
            'modified'=>esc_html__('Modified','nuno-builder') ),
          'type' => 'dropdown',
          'default'=>'date'
         ),         
        array( 
          'heading' => esc_html__( 'Order', 'nuno-builder' ),
          'param_name' => 'order',
          'class' => '',
          'value' => array(
            ''=>esc_html__('Default','nuno-builder') ,
            'desc'=>esc_html__('Descending','nuno-builder') ,
            'asc'=>esc_html__('Ascending','nuno-builder') ) ,
          'type' => 'dropdown',
          'default'=>'center'
         ),         
       )
     )
);

}
?>
