<?php
defined('ABSPATH') or die();
/**
 * @package WordPress
 * @subpackage Petro
 * @since Petro 2.2.2
 */

// sidebar widget

function petro_register_sidebar(){


	register_sidebar(
		array('name'=> esc_html__( 'Sidebar','petro'),
			'id'	=>'sidebar-widget',
			'description'=> esc_html__('The widget will displayed at left/right off main content.', 'petro'),
			'before_widget' => '<div class="widget %s %s">',
			'after_widget' => '</div>',
			'before_title' => '<div class="h6 widget-title">',
			'after_title' => '</div>'
		)
	);


	register_sidebar(
		array('name'=> esc_html__( 'Slidingbar','petro'),
			'id'	=>'slidingbar-widget',
			'description'=> esc_html__('The widget will displayed at sliding bar (side menu).', 'petro'),
			'before_widget' => '<div class="widget %s %s">',
			'after_widget' => '</div>',
			'before_title' => '<div class="h6 widget-title">',
			'after_title' => '</div>'
		)
	);


	register_sidebar(
		array('name'=> esc_html__( 'Bottom','petro'),
			'id'	=>'footer-widget',
			'description'=> esc_html__('The widget will displayed at bottom area before footer text.', 'petro'),
			'before_widget' => '<div class="widget %s %s">',
			'after_widget' => '</div>',
			'before_title' => '<div class="h6 widget-title">',
			'after_title' => '</div>'
		)
	);

	if(class_exists('TG_Custom_Post')){
		register_sidebar(
			array('name'=> esc_html__( 'Portfolio Page','petro'),
				'id'	=>'portfolio-widget',
				'description'=> esc_html__('The widget will displayed at detail portfolio post.', 'petro'),
				'before_widget' => '<div class="widget %s %s">',
				'after_widget' => '</div>',
				'before_title' => '<div class="h6 widget-title">',
				'after_title' => '</div>'
			)
		);

		add_filter('tg_custom_post_metabox_title', 'petro_tg_custom_post_metabox_title' );

	}

	if(class_exists('petro_service')){
		register_sidebar(
			array('name'=> esc_html__( 'Service Page','petro'),
				'id'	=>'service-widget',
				'description'=> esc_html__('The widget will displayed at detail service post.', 'petro'),
				'before_widget' => '<div class="widget %s %s">',
				'after_widget' => '</div>',
				'before_title' => '<div class="h6 widget-title">',
				'after_title' => '</div>'
			)
		);

	}

	if (function_exists('is_shop')) {

		register_sidebar(
			array('name'=> esc_html__('Shop Sidebar Widget Area', 'petro'),
				'id'=>'shop-sidebar',
				'description'=> esc_html__('Sidebar will display on woocommerce page only', 'petro'),
				'before_widget' => '<div class="widget %s %s">',
				'after_widget' => '</div>',
				'before_title' => '<div class="h6 widget-title">',
				'after_title' => '</div>'
			));

	}


}


add_action('widgets_init', 'petro_register_sidebar',1);

?>
