<?php
/**
 * The search result template file
 *
 * This is the most generic template file in a WordPress theme and one
 * of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query,
 * e.g., it puts together the home page when no home.php file exists.
 *
 * @link http://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Petro
 * @since Petro 2.1.7
 */
get_header('blog');


$grid_column = petro_get_config( 'search_grid_column', 1 );
$content_renderer = petro_get_config( 'search_content_render', '' );

$lite = absint($grid_column) > 1 ? '-lite': ($content_renderer=='content' ? "-full":"");

$grid_css= array('grid-column',"col-xs-12");
$lg = 12 / $grid_column;
$grid_css[] = "col-lg-".$lg;
if($lg < 12 ) $grid_css[] = 'col-md-6';
$grid_class = join(' ',array_unique($grid_css));

$rows= array();


if ( have_posts() ) : 
?>
<h1 class="post-title bot-m40"><?php printf( esc_html__('Search result for %s','petro'),'<span>"'.get_search_query().'"</span>');?></h1>
<div class="bottom-devider"></div>
<div id="post-lists" class="post-lists blog-col-<?php print sanitize_html_class($grid_column);?>  clearfix">
<?php
while ( have_posts() ) :

ob_start();
the_post();
$post_format= get_post_format();

get_template_part( 'template-part/content'.$lite, $post_format ); 
$rows[] = ob_get_clean();

endwhile;


if(count($rows)):?>
	<div class="<?php print esc_attr($grid_class);?>">
	<?php print join('</div><div class="'.esc_attr($grid_class).'">',$rows);?>
	</div>
<?php
endif;

unset($rows);
?>
</div>
<div class="clearfix"></div>
<?php 
$args=array("before"=>"<li>","after"=>"</li>","wrapper"=>"<div class=\"pagination %s\" dir=\"ltr\"><ul>%s</ul></div>",'navigation_type'=>'number');
petro_pagination($args);
 ?>
<?php else:?>
<div class="col-xs-12">
	<div class="search-404 bot-p80">
<?php 

$error_text=petro_get_config('search-empty-text','');

if($error_text!=''){
	print do_shortcode($error_text);
}
else{?>
		<h2 class="top-m0" ><?php esc_html_e( 'Nothing Found','petro' );?></h2>
		<h4><?php esc_html_e( 'Sorry, but nothing matched your search terms.','petro' );?></h4>		
		<p><?php esc_html_e( 'Please try again with some different keywords.', 'petro' ); ?></p>
<?php } ?>
	</div>					
</div>	
<?php endif;?>
<?php
get_footer();
?>