<?php
defined('ABSPATH') or die();
/**
 * The default template for displaying content
 *
 * Used for  single post.
 *
 * @package WordPress
 * @subpackage Petro
 * @since Petro 1.0.0
 */

?>
<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
	<div class="post-content">
		<?php 
$blog_layout = petro_get_config( 'blog-layout', array());
$layout = isset($blog_layout['active']) ? $blog_layout['active'] : array('image','title','meta','content','author');

if(isset($layout['placebo'])){
	unset($layout['placebo']);
}
elseif(isset($layout['fields'])){
	$layout = $layout['fields'];
}

if(count($layout)){
	foreach ($layout as $layout_name => $layout_label) {	
		get_template_part( 'template-part/single/post', $layout_name);
	}
}

?>
	</div>
	<hr/>
<?php 


$post_params=array( 
  'posts_per_page' => 5,
  'no_found_rows' => true,
  'post_status' => 'publish',
  'post__not_in' => array(get_the_ID()),
  'ignore_sticky_posts' => 1
);

$cat_options= $tag_options = array();

$categories = get_the_category();
$tags = get_the_tags();

if($categories){
  foreach ($categories as $category) {
    $cat_options[]= $category->term_id;
  }
}

if(count($cat_options)){
  $post_params['cat'] = $cat_options;	
}

if($tags){
  foreach ($tags as $tag) {
    $tag_options[]= $tag->term_id;
  }
}

if(count($tag_options)){
  $params['tax_query'] = array(
    array(
      'taxonomy' => 'post_tag',
      'field' => 'id',
      'terms' => $tag_options,
      'operator' => 'OR'
    )
  );

}

$query = new WP_Query($post_params);
if ($query->have_posts()):?>
    <div class="related-posts clearfix">
    <h2 class="h4 related-post-title"><i class="fa fa-lg fa-book"></i> <?php esc_html_e('Related Articles','petro');?></h2>
    <ul class="square">
    <?php while ( $query->have_posts() ) : 
    $query->the_post();?>
    <li><a href="<?php the_permalink();?>"><?php the_title();?></a></li>
    <?php endwhile;
    wp_reset_postdata();?>
	</ul>
    </div>
    <div class="clearfix"></div>
<?php endif; ?>
</article>