<?php
defined('ABSPATH') or die();
/**
 * @package WordPress
 * @subpackage Petro
 * @since Petro 1.0.0
 */



$navigation_class = array('navigation-bar');

if(($layout_mode = petro_get_config('sticky-layout-mode')) ){
  array_push($navigation_class, $layout_mode);
}

if(petro_get_config('sticky_menu',false)){
  array_push($navigation_class, 'sticky');

  if(($stickymobile = petro_get_config('sticky-mobile')) ){
    array_push($navigation_class, 'mobile-sticky');
  }

} 


?>
<?php get_template_part( 'template-part/top-heading'); ?>
<div class="<?php print join(' ', $navigation_class);?>">
  <div class="container">
    <div class="navigation-bar-inner">
<?php


  $regular_logo_id = get_theme_mod( 'custom_logo' );

  if ( $regular_logo_id ) {
    
    printf( '<a href="%1$s" class="regular-logo custom-logo-link" rel="home">%2$s</a>',
      esc_url( home_url( '/' ) ),
      wp_get_attachment_image( $regular_logo_id, 'full', false, array(
        'class'    => '',
      ) )
    );
  }else{

    $blogname = $blogtitle = get_bloginfo('name');
    print '<p class="logo-text custom-logo-link"><a  href="'.esc_url(home_url('/')).'" title="'.esc_attr($blogtitle).'">'.$blogname.'</a></p>';

  }


  $sticky_logo_id = get_theme_mod( 'custom_logo_alt' );
  
  if ( $sticky_logo_id ) {
    
    printf( '<a href="%1$s" class="sticky-logo custom-logo-link" rel="home">%2$s</a>',
      esc_url( home_url( '/' ) ),
      wp_get_attachment_image( $sticky_logo_id, 'full', false, array(
        'class'    => '',
      ) )
    );
  }


?>
<button class="navbar-toggle toggle-main-menu" type="button" onclick="javascript:;" data-toggle="collapse" data-target=".navigation-bar-mobile">
    <span class="menu-bar">
      <span></span>
      <span></span>
      <span></span>
    </span>
  </button>
<?php
if(petro_get_config('sticky_menu',false)){
  get_template_part( 'template-part/sticky-bar'); 
}
?>
    </div>
   <div class="navigation-bar-mobile collapse"></div>
  </div>
</div>
<?php 

$hide_heading = petro_get_config('hide_title',false);

//disable_heading
if(!$hide_heading){

  the_custom_header_markup();
} 

$the_title = petro_get_config('search_heading_title','');

if($the_title!='') {
    $section_title='<div class="search-name h2">'.$the_title.'</div>';
}

?>
<div class="custom-page-title align-center">
  <div class="container">
<?php
     if($section_title !='') { 

        print  "{$section_title}";
      }
?>
    <div class="search-result-form">
    <?php    get_search_form(); ?>
    </div>
  </div>
</div>
